using System.Collections;
using System.Collections.Generic;
using UnityEngine;
/*Sample script to use the interpolated positions of the joints*/
public class CalculatePositions : MonoBehaviour
{
    ShockwaveManager manager;
    // Start is called before the first frame update
    void Start()
    {
        manager = ShockwaveManager.Instance;
        manager.StartPositionComputation(0);//Call the manager to start the interpolation thread. The headset needs to be assigned in the manager to interpolate the positions of the rest of hte joints.
    }


    // Update is called once per frame
    void Update()
    {
        int index = 0;
        foreach(Transform child in transform)
        {
            child.position = TrackerPosition(index);
            
                index++;
        }
    }
    public Vector3 TrackerPosition(int index)
    {
        float[] trackerPos = new float[3];

        trackerPos = manager.GetTrackerPosition(index); 
        return new Vector3(trackerPos[0], trackerPos[1], trackerPos[2]);
    }
    void OnDisable()
    {
        manager.StopPositionComputation();
    }
}
