﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
/*Attach this object to a constrained rigibody or an even unconstrained one if you do not want the physics engine to resolve the impulse
 * The script will calculate the impulse of the hit.This is useful for instance using melee weapons which go inside the body
 */
public class ConstrainedRigidBodyDynamics : MonoBehaviour
{
    
    Vector3 velocity, lastPosition;
    Quaternion angularVelocity, quat;
    public int elasticity = 1;
   
  
   
    void Start()
    {
       
        lastPosition = transform.position;
     
    }
  

    void FixedUpdate()
    {
        velocity = (transform.position - lastPosition) / Time.fixedDeltaTime;
        lastPosition = transform.position;
        angularVelocity = (transform.rotation * quat);//This is change not angular velocity.but subtracting the identity quaternion operation per delta time is the angular velocity.
        quat = Quaternion.Inverse(transform.rotation);
    }
   
    public Vector3 GetVelocity()
    {
        return velocity;
    }
    public Vector3 GetVelocityAtPoint(Vector3 worldPos)
    {
        Vector3 relativePos = worldPos - transform.position;
        return velocity + (angularVelocity * (relativePos) - relativePos) / Time.fixedDeltaTime;
    }
 
  
}