using System.Collections;
using System.Collections.Generic;
using UnityEngine;


#if UNITY_EDITOR
using UnityEditor;
[CustomEditor(typeof(hapticModelBones))]
public class hapticModelBonesInspector : Editor {
    private hapticModelBones bonesModel;
    private Transform[] bones;
    public Transform PelvisTransform { get { return bones[0]; } set { bones[0] = value; } }
    public Transform LeftThighTransform { get { return bones[1]; } set { bones[1] = value; } }
    public Transform RightThighTransform { get { return bones[2]; } set { bones[2] = value; } }
    public Transform LeftCalfTransform { get { return bones[3]; } set { bones[3] = value; } }
    public Transform RightCalfTransform { get { return bones[4]; } set { bones[4] = value; } }
    public Transform LeftFootTransform { get { return bones[5]; } set { bones[5] = value; } }
    public Transform RightFootTransform { get { return bones[6]; } set { bones[6] = value; } }
    public Transform SpineHipTransform { get { return bones[7]; } set { bones[7] = value; } }
    public Transform RightClavicleTransform { get { return bones[8]; } set { bones[8] = value; } }
    public Transform LeftClavicleTransform { get { return bones[9]; } set { bones[9] = value; } }
    public Transform RightUpperArmTransform { get { return bones[10]; } set { bones[10] = value; } }
    public Transform LeftUpperArmTransform { get { return bones[11]; } set { bones[11] = value; } }
    public Transform HeadTransform { get { return bones[12]; } set { bones[12] = value; } }
    public Transform RightLowerArmTransform { get { return bones[13]; } set { bones[13] = value; } }
    public Transform LeftLowerArmTransform { get { return bones[14]; } set { bones[14] = value; } }
    public Transform RightHandTransform { get { return bones[15]; } set { bones[15] = value; } }
    public Transform LeftHandTransform { get { return bones[16]; } set { bones[16] = value; } }
    public Transform SpineTorsoTransform { get { return bones[17]; } set { bones[17] = value; } }

    public override void OnInspectorGUI() {
        bonesModel = target as hapticModelBones;
        bones = bonesModel.bones;

        PelvisTransform = EditorGUILayout.ObjectField("Pelvis", PelvisTransform, typeof(Transform), true) as Transform;
        LeftThighTransform = EditorGUILayout.ObjectField("Left Thigh", LeftThighTransform, typeof(Transform), true) as Transform;
        RightThighTransform = EditorGUILayout.ObjectField("Right Thigh", RightThighTransform, typeof(Transform), true) as Transform;
        LeftCalfTransform = EditorGUILayout.ObjectField("Left Calf", LeftCalfTransform, typeof(Transform), true) as Transform;
        RightCalfTransform = EditorGUILayout.ObjectField("Right Calf", RightCalfTransform, typeof(Transform), true) as Transform;
        LeftFootTransform = EditorGUILayout.ObjectField("Left Foot", LeftFootTransform, typeof(Transform), true) as Transform;
        RightFootTransform = EditorGUILayout.ObjectField("Right Thigh", RightFootTransform, typeof(Transform), true) as Transform;
        SpineHipTransform = EditorGUILayout.ObjectField("Spine Hip", SpineHipTransform, typeof(Transform), true) as Transform;
        RightClavicleTransform = EditorGUILayout.ObjectField("Left Clavicle", RightClavicleTransform, typeof(Transform), true) as Transform;
        LeftClavicleTransform = EditorGUILayout.ObjectField("Left Clavicle", LeftClavicleTransform, typeof(Transform), true) as Transform;
        RightUpperArmTransform = EditorGUILayout.ObjectField("Right Upper Arm", RightUpperArmTransform, typeof(Transform), true) as Transform;
        LeftUpperArmTransform = EditorGUILayout.ObjectField("Left Upper Arm", LeftUpperArmTransform, typeof(Transform), true) as Transform;
        HeadTransform = EditorGUILayout.ObjectField("Head", HeadTransform, typeof(Transform), true) as Transform;
        RightLowerArmTransform = EditorGUILayout.ObjectField("Right Lower Arm", RightLowerArmTransform, typeof(Transform), true) as Transform;
        LeftLowerArmTransform = EditorGUILayout.ObjectField("Left Lower Arm", LeftLowerArmTransform, typeof(Transform), true) as Transform;
        RightHandTransform = EditorGUILayout.ObjectField("Right Hand", RightHandTransform, typeof(Transform), true) as Transform;
        LeftHandTransform = EditorGUILayout.ObjectField("Left Hand", LeftHandTransform, typeof(Transform), true) as Transform;
        SpineTorsoTransform = EditorGUILayout.ObjectField("Spine Torso", SpineTorsoTransform, typeof(Transform), true) as Transform;
    }
}
#endif
