using System.Collections;
using System.Collections.Generic;
using UnityEngine;
//using Valve.VR;
using UnityEngine.InputSystem;
using UnityEngine.XR.OpenXR.Input;
//using UnityEngine.XR.OpenXR.Samples.ControllerSample;

public class Shockwave_FireProjectiles : MonoBehaviour
{
    // Start is called before the first frame update
    public GameObject projectilePrefab, EjectionPoint;
    public ParticleSystem EjectionEffect;
    public float ProjectileSpeed = 5;
    public AudioSource projectileSound;
  // public SteamVR_Action_Boolean Trigger;
  //  public SteamVR_Input_Sources hand;
    [SerializeField] private InputActionReference _actionReference = null;

    void OnEnable()
    { if (_actionReference != null)
        {
            _actionReference.action.Enable();
            _actionReference.action.performed += (ctx) =>
            {
                ShootProjectile();
               
            };
        }
   //    else if (Trigger != null)
      //    Trigger.AddOnStateDownListener(TriggerDown, hand);
        
    }

   void OnDisable()
    {
        if (_actionReference != null)
        {
            
            _actionReference.action.performed -= (ctx) =>
            {
                ShootProjectile();
        
            };
            _actionReference.action.Disable();
        }
     //   else if (Trigger != null)
      //    Trigger.RemoveOnStateDownListener(TriggerDown, hand);
      
    }

  /*  void TriggerDown(SteamVR_Action_Boolean Action, SteamVR_Input_Sources source)
   {
       ShootProjectile();
    }*/
    private void ShootProjectile()
    {
      
        if (projectilePrefab != null && EjectionPoint != null)
        {
            GameObject projectile = Instantiate(projectilePrefab, EjectionPoint.transform.position, EjectionPoint.transform.rotation);
            Rigidbody projectileRigidbody = projectile.GetComponent<Rigidbody>();
            if (projectileRigidbody != null)
            {
                if (projectile.GetComponent<ConstrainedRigidBodyDynamics>() == null)
                    projectileRigidbody.AddForce(projectile.transform.forward * ProjectileSpeed, ForceMode.Impulse);
                else
                    projectileRigidbody.velocity = projectile.transform.forward * ProjectileSpeed;
            }
            if (projectileSound != null)
                projectileSound.Play();
            Destroy(projectile, 2);
        }
    }
}
