using System.Collections;
using System.Collections.Generic;
using UnityEngine;
/*Sample script to demonstrate how to utilize multi channel 3d audio to acutate activate LEDs on the logo
 */
public class AudioToLED : MonoBehaviour
{
    float[] leftColor=new float[3];
    float[] rightColor = new float[3];
    Color leftBassColor;
    Color leftTrebleColor;
    Color rightBassColor;
    Color rightTrebleColor;
    float[] leftspectrum = new float[64];
    float[] rightspectrum = new float[64];
    float bassRatio = 0.33f;
    bool Mirror = false;
    ShockwaveManager manager;
    void Start()
    {
        manager = ShockwaveManager.Instance;
    }

    void Update()
    {
       
        //Stereo sound in left right channels
        AudioListener.GetSpectrumData(leftspectrum, 0, FFTWindow.Rectangular);
        AudioListener.GetSpectrumData(rightspectrum, 1, FFTWindow.Rectangular);
        float leftBass = 0, leftTreble = 0;
        float rightBass = 0, rightTreble = 0;
        for (int i = 0; i < (int)(leftspectrum.Length * bassRatio); i++)
        {
            leftBass += leftspectrum[i];
            rightBass += rightspectrum[i];
        }
      

        for (int i = (int)(leftspectrum.Length * bassRatio); i < leftspectrum.Length; i++)
        {
            leftTreble += leftspectrum[i];
            rightTreble += rightspectrum[i];
        }
        leftColor[0] = (leftBass * leftBassColor.g + leftTreble * leftTrebleColor.g);
        leftColor[1] = (leftBass * leftBassColor.r + leftTreble * leftTrebleColor.r);
        leftColor[2]= (leftBass * leftBassColor.b + leftTreble * leftTrebleColor.b);
        rightColor[0]= (rightBass * rightBassColor.g + rightTreble * rightTrebleColor.g);
        rightColor[1]= (rightBass * rightBassColor.r + rightTreble * rightTrebleColor.r);
        rightColor[2]= (rightBass * rightBassColor.b + rightTreble * rightTrebleColor.b);

        {
            manager.sendLEDUpdate(leftColor, true);
            manager.sendLEDUpdate(rightColor, false);


        }
        /*  //An equalizer graph to visualize the audio
          for (int i = 1; i < spectrum.Length - 1; i++)
          {
              Debug.DrawLine(new Vector3(i - 1, spectrum[i] + 10, 0), new Vector3(i, spectrum[i + 1] + 10, 0), Color.red);
              Debug.DrawLine(new Vector3(i - 1, Mathf.Log(spectrum[i - 1]) + 10, 2), new Vector3(i, Mathf.Log(spectrum[i]) + 10, 2), Color.cyan);
              Debug.DrawLine(new Vector3(Mathf.Log(i - 1), spectrum[i - 1] - 10, 1), new Vector3(Mathf.Log(i), spectrum[i] - 10, 1), Color.green);
              Debug.DrawLine(new Vector3(Mathf.Log(i - 1), Mathf.Log(spectrum[i - 1]), 3), new Vector3(Mathf.Log(i), Mathf.Log(spectrum[i]), 3), Color.blue);
          }*/
    }
    public void ColorPickerLEDBassLeft(Color col)
    {

        leftBassColor = col;

        leftTrebleColor.g = 1 - col.g; leftTrebleColor.r = 1 - col.r; leftTrebleColor.b = 1 - col.b;
        if (Mirror)
        {
            rightBassColor = col;

            rightTrebleColor.g = 1 - col.g; rightTrebleColor.r = 1 - col.r; rightTrebleColor.b = 1 - col.b;
        }


    }
    public void ColorPickerLEDBassRight(Color col)
    {

        rightBassColor = col;

        rightTrebleColor.g = 1 - col.g; rightTrebleColor.r = 1 - col.r; rightTrebleColor.b = 1 - col.b;
        if (Mirror)
        {
            leftBassColor = col;

            leftTrebleColor.g = 1 - col.g; leftTrebleColor.r = 1 - col.r; leftTrebleColor.b = 1 - col.b;
        }


    }
    public void Bassstrength(float f)
    {
        bassRatio = 0.33f * f;
    }
    public void MirrorEnabled(bool m)
    {
        Mirror = !m;
    }
}
