using System.Collections;
using System.Collections.Generic;
using UnityEngine;
/*The script showcases how to control the RGBs on the suit to adapt to your game*/
public class LEDControl : MonoBehaviour
{
    ShockwaveManager manager;
    float[] leftColor = new float[3];
    float[] rightColor = new float[3];
    bool ledupdate = false, mirrored = false;
    
    void Start()
    {
        manager = ShockwaveManager.Instance;
    }

  
    void Update()
    {
        if ( ledupdate)
        {

            manager.sendLEDUpdate(leftColor, true);//Second parameter true for left LEDs
            manager.sendLEDUpdate(rightColor, false);
        }
    }
    public void ColorPickerLEDLeft(Color col)
    {
        leftColor[0] = col.g; leftColor[1] = col.r; leftColor[2] = col.b;
        manager.sendLEDUpdate(leftColor, true);
        if(mirrored)
        {
            rightColor[0] = col.g; rightColor[1] = col.r; rightColor[2] = col.b;
            manager.sendLEDUpdate(rightColor,false);
        }
    }
    public void ColorPickerLEDRight(Color col)
    {

        rightColor[0] = col.g; rightColor[1] = col.r; rightColor[2] = col.b;
        manager.sendLEDUpdate(rightColor, false);
        if (mirrored)
        {
            leftColor[0] = col.g; leftColor[1] = col.r; leftColor[2] = col.b;
            manager.sendLEDUpdate(leftColor, true);
        }
    }
    public void ContinuousUpdate(bool u)
    {
        ledupdate = u;
    }
    public void MirrorEnabled(bool m)
    {
        mirrored = !m;
    }
}
